package
{
	// you'll need to change this to your path, you'll also need to change the package definition of CameraBitmapData
	import com.noodlebox.util.CameraBitmapData;
	
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	
	[SWF(width="800", height="600", backgroundColor="#000000", frameRate="30")]
	
	public class Difference2 extends Sprite
	{

		public var canvasWidth:int = 800, canvasHeight:int = 600 ;
		public var halfWidth:int = canvasWidth / 2, halfHeight:int = canvasHeight / 2 ;
		
		public var canvasBDs:Vector.<BitmapData>, canvasBMs:Vector.<Bitmap> ;
		public var canvasBD:BitmapData, canvasBM:Bitmap ;
		
		public var camBD:CameraBitmapData, differenceBD:BitmapData, oldCamBD:BitmapData;
		
		// tools
		public var g:Graphics;
		public var t:Number = 0, b:Number = 0, n:Number = 0, a:Number, u:Number = 0, l:Number = 2;
		
		public function Difference2()
		{
			
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
			
		}
		
		private function init(e:Event = null):void {
						
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			this.stage.scaleMode = StageScaleMode.NO_SCALE;
			this.stage.align = StageAlign.TOP_LEFT;
			
			g = this.graphics;
			
			//
			
			camBD = new CameraBitmapData(canvasWidth,canvasHeight,15,1280,1024,false,true,1);
			oldCamBD = camBD.clone();
			
			var tbm:Bitmap = new Bitmap(camBD);
			tbm.alpha = 0.5;
			addChild(tbm);
			
			canvasBD = new BitmapData( canvasWidth, canvasHeight, false, 0);
			canvasBM = new Bitmap( canvasBD ) ;
			
			differenceBD = new BitmapData( canvasWidth, canvasHeight, false, 0);
			
			canvasBMs = new Vector.<Bitmap>;
			
			var zoomFactor:Number=0.2;
			
			for (var i:int=0;i<=l;i++) {
				
				var tBM:Bitmap = new Bitmap(canvasBD);
				canvasBMs.push(tBM);
				addChild(tBM);
				
				tBM.width = canvasBD.width*(1.0+((zoomFactor)*i/l));
				tBM.height = canvasBD.height*(1.0+((zoomFactor)*i/l));
				
				tBM.x = (canvasWidth/2)-(tBM.width/2);
				tBM.y = (canvasHeight/2)-(tBM.height/2);
				
				tBM.blendMode="add";
				
			}
			
			//
			
			/* This won't work in the OS version as I haven't included the class
			var buttonRow:Array = new Array;
			
			var ttb:TextButton=new TextButton("Mirror",0xffffff, 0x888888, 0xff000000);
			if (buttonRow.length!=0) ttb.x = buttonRow[buttonRow.length-1].x+buttonRow[buttonRow.length-1].width+2;
			ttb.y=canvasHeight-16;
			buttonRow.push(ttb);
			addChild(ttb);
			
			ttb.addEventListener(MouseEvent.MOUSE_UP,function(e:Event=null){camBD.mirror=!camBD.mirror;});
			*/
			
			//
			
			this.addEventListener(Event.ENTER_FRAME, onEnterFrame);
						
		}
		
		public function onEnterFrame(e:Event):void {

			canvasBD.colorTransform(canvasBD.rect,new ColorTransform(1,1,1,1,b=-5,b,b));

			if ( camBD.uniqueFrameID != u ) {
				
				differenceBD.copyPixels(oldCamBD,differenceBD.rect,new Point);
				differenceBD.draw(camBD,null,null,"difference");
																
				canvasBD.draw(differenceBD,null,new ColorTransform(Math.sin(t)*0.5+0.5,Math.sin(t*0.4)*0.5+0.5,Math.sin(t*0.9)*0.5+0.5,1,b=-15,b,b),"add");
				
				oldCamBD.copyPixels(camBD,camBD.rect,new Point);
				
				u = camBD.uniqueFrameID;
				t += 0.4;
				
			}
			
		}
		
		public function onResize(e:Event=null):void {
			
		}
		
		public function onPreloaded(e:Event=null):void {
			
		}
		
		public function onMouseUp(e:MouseEvent):void{
			
		}
		
		public function onKeyDown(e:KeyboardEvent):void{
			
		}
		
		public function onKeyUp(e:KeyboardEvent):void{
			
		}
		
	}
	
}
